<?php

/*
Plugin Name: NATS Code
Plugin URI: http://wiki.toomuchmedia.com/index.php/NATS_Code_Wordpress_Plugin
Description: Allows you to insert NATS tracking codes into Wordpress posts.
Version: 0.1
Author: Too Much Media
Author URI: http://www.toomuchmedia.com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

/* Start main important code */
function natscode_filter($post_text) {
	
	/* find all instances of [nats|something] or [nats] and replace them with the appropriate nats code */
	$post_text = preg_replace_callback('/\[(nats[^]]*)]/','natscode_filter_callback',$post_text);

	return $post_text;
}

function natscode_filter_callback($replace) {
	
	static $defaultdefaultnats = false;
	$nats = $_GET['nats']; // query string comes first
	if(!$nats) {
		list(,$defaultnats) = explode('|',$replace[1]);
		$nats = $defaultnats; // inline nats code comes next
	}
	if(!$nats) {
		if(!$defaultdefaultnats) $defaultdefaultnats = get_option('natscode_default_code');
		$nats = $defaultdefaultnats; // default code in admin comes last
	}

	return $nats;
}
/* End main important code */

function natscode_options() { 
	if($_POST['natscode_save']){
		update_option('natscode_default_code',$_POST['natscode_default_code']);
		echo '<div class="updated"><p>Default NATS code updated.</p></div>';
	}
	
	?>
	<div class="wrap">
	<h2>NATS Code Options</h2>
	<form method="post" id="natscode_options">
		<fieldset class="options">
		<table width="100%" cellspacing="2" cellpadding="5" class="editform">
			<tr valign="top">
				<th width="33%" scope="row">Default NATS Code:</th>
				<td><input name="natscode_default_code" type="text" id="natscode_default_code" value="<?php echo get_option('natscode_default_code') ;?>" size="15" />
				<br />Sets the default NATS code to use if there is no NATS code in the query string, and no NATS code is specified in line.
				<?php if(!get_option('natscode_default_code')) { ?>
				<br/><strong>You do not currently have a default NATS code set</strong>. If you do not have a NATS code set inline for every surfer link, you may
				send surfers to a blank page!<?php } ?>
				</td>
			</tr>
		</table>
		<p class="submit"><input type="submit" name="natscode_save" value="Save" /></p>
		</fieldset>
	</form>
	</div>
	<?php
}
		
function natscode_adminmenu(){
	add_options_page('NATS Code Options', 'NATS Code', 9, 'natscode.php', 'natscode_options');
}


add_filter('the_content', 'natscode_filter', 2);
add_action('admin_menu','natscode_adminmenu',1);

?>
